import numpy as np
RM_FEATURES = np.array([["QUOTES","QUOTE"], ["QUOTE","QUOTES"], ["OCEANS", "OCEAN"], ["BEACHES", "BEACH"],
                ["WOMEN","WOMAN"], ["BEARS","BEAR"], ["DESERTS","DESSERTS"], ["SKELETONS","SKELETON"],
                ["RABBITS","RABBIT"], ["CATS","CAT"], ["FLOWERS","FLOWER"], ["BOUQUET_OF_FLOWER","FLOWER"],  
                ["SKY__SPACE","SKY"], ["SKY_SPACE","SKY"], ["FLOWER_VASES","VASES"], ["BIRTHDAY_CAKES","CAKES"],
                ['BRIDGES', 'BRIDGE'], ['CAKESS', 'CAKES'], ['CARS', 'CAR'],['DINOSAURS', 'DINOSAUR'],
                 ['LAKES', 'LAKE'], ['MARGARITAS', 'MARGARITA'], ['NATIVE_AMERICANS', 'NATIVE_AMERICAN'], 
                 ['OCEAN/BEACHS', 'OCEAN/BEACH'], ['ORANGES', 'ORANGE'], ['SCHOOLS', 'SCHOOL'],['WINES', 'WINE'],
                ["BIRTHDAY_CANDLES","CANDLES"], ["WOLVES_","WOLVES"], ["HIPPOPOTAMUS", "HIPPO"], ["DINGOS", "DINGO"], 
                ["GIFTS", "WRAPPED_GIFTS"],[".", ""], ["QUEENS", "PRINCESS"], ["WHISKY","WHISKEY"], ["ROMANESCO_BROCCOLI", "BROCCOLI"],
                 ['WOODS', 'WOOD'], ['NEW_YORK_CITY', 'NEW_YORK'], ["USA", "UNITED_STATES"], ["JUNGLE","FORESTS"],
                ["PARTY", "PARTIES"], ["BLUE_SKY", "SKY"], ["WILDFLOWER", "FLOWER"], ["BUNNIES", "RABBIT"], ["EASTER_CHICKS", "CHICKS"], ["EASTER_BUNNY", "RABBIT"],
                ])

# Grouping of common features 
OBJECTS = {
# can be described as "this is a photo of {OBJECT}, a type of {GROUP}"
    
"ANIMALS":[ "DOGS", "BIRDS", "CAT", "BLACK_CAT",  "HORSES", "SHEEP", "BUTTERFLIES", "INSECTS", "BEAR",  "BUNNIES", "RABBIT", "DEER", "SQUIRRELS", "FROGS", "AMPHIBIANS", "BEES", "BATS", "BUFFALOS",  "CHIHUAHUAS", "COWS", "CROCODILES", "DINOSAURS", "HIPPOPOTAMUS", "DRAGONFLIES", "ELEPHANTS", "FISH", "FOXES", "GIRAFFES", "GOATS", "LADYBUGS", "LAMBS", "LIZARDS", "LLAMAS", "MICE", "OCTOPUSES", "OTTERS", "OXEN", "PANDAS", "PENGUINS", "PIGS", "POLAR_BEAR", "RACCOONS", "RATS", "REINDEER", "REPTILES",  "SLOTHS", "SPIDERS", "TIGERS", "TREX", "WHALES", "WOLVES", "TURTLES", "ZEBRAS","SEALS", "BEARS", "MONKEYS", "DINGO", "MOOSE",   "BULLS",  "KOALAS", "ALPACAS", "ANEMONES", "BADGERS", "BEAVERS", "BLACK_SHEEP", "BUCKS", "CAMELS", "CHIPMUNKS", "COYOTES", "CRABS", "DOLPHINS", "DONKEYS", "ELK", "ERMINES", "GORILLAS", "GROUND_HOGS", "HAMSTERS", "HARES", "HEDGEHOGS", "HONEY_BADGERS", "KANGAROOS", "MANATEES", "MARMOTS", "MULES", "NUMBATS", "OPOSSUMS", "ORANGUTANS", "PETS", "PLANKTON",  "RHINOCEROS", "SEAHORSES", "SNAILS", "SNAKES", "SQUIDS", "STARFISH", "WALRUS", "WILDEBEEST", "WOLVERINES", "WORMS"],

"FISH": ["ANGLER_FISH", "BROOK_TROUT", "CARP", "COD", "GOLDFISH", "KOI",  "SHARKS", "JELLYFISH", "KILLER_WHALES", ],


"BIRDS": ["FLAMINGOS", "EAGLES", "CROWS", "CRANES", "CARDINALS", "HUMMINGBIRDS", "LOVE_BIRDS", "PARROTS", "PEACOCKS", "PELICANS", "RAVENS", "SWANS", "NIGHTHAWKS", "SAND_PIPERS", 
"COCKATOOS", "AMERICAN_ROBINS", "BLUE_JAYS", "BUZZARDS", "CACTUS_WREN", "CHICKADEES", "CHICKENS", "CHICKS", "DOVES","DUCKLINGS", "DUCKS", "EASTERN_BLUEBIRDS", "EMUS", "FALCONS", "FEATHERS", "GOOSE", "HAWKS", "HERONS", "IBIS", "MOUNTAIN_BLUEBIRDS", "OSPREY", "OSTRICH", "OWLS", "PARTRIDGES", "PHEASANTS", "PIGEONS", "PUFFINS", "QUAIL", "ROOSTERS", "SEAGULLS", "SHORE_BIRDS", "STORKS", "THUNDERBIRDS", "TOUCANS", "TURKEYS", "VULTURES", "WARBLERS", "WESTERN_SWALLOWTAILS", "WHOOPING_CRANES", "WILLET", "WOODPECKERS"
],

"DOGS": ["GOLDEN_RETRIEVERS", "BULLDOGS", "DACHSHUNDS", "HUSKY", "LABRADORS", "POODLES", "PUGS","TERRIERS","SHEEP_DOGS","SPANIELS", "SCOTTISH_TERRIER", "DALMATIONS", ],

"CAT": ["AMERICAN_SHORTHAIR", "BENGAL", "BOMBAY", "BRITISH_SHORTHAIR", "RUSSIAN_BLUE", "SCOTTISH_FOLD", "ABYSSINIANS", "BLACK_CATS", "CALICO", "CHEETAHS", "COUGARS", "KITTENS", "LEOPARDS", "LIONS", "LYNX", "MOUNTAIN_LIONS", "PANTHERS", "PUMAS", "SIAMESE", "TABBY"] ,

    
# Not able to detect poodles.
# poppies are detected as poodles
    
"FLOWER":["ROSES", "TULIPS", "SUNFLOWER", "DAISIES", "CALLA_LILY", "CHRYSANTHEMUMS", "DAFFODILS", "DANDELIONS", "IRIS", "LILLIES", "LOTUS", "ORCHIDS", "POINSETTIAS", "POPPIES", "WATER_LILY", "CACTUS_BLOSSOMS", "LAVENDER","PASSION_FLOWERS", "MARIGOLDS",   "PLUMERIAS", "CHERRY_BLOSSOMS" ],
    
"PLANTS": ["FLOWER", "TREES", "SHAMROCKS", "CACTUS", "CLOVERS", "GRASS", "LEAVES", "PALM_TREES", "PINE_TREES", "BAMBOO", "FERNS"],
    
"DRINKS": ["COFFEE", "TEAS", "HOT_CHOCOLATE","LATTES", "MOCHAS",],

"ALCOHOL":["WHISKEY", "WINE", "BEER", "COCKTAILS", "PINTS","CHAMPAGNE", ],

"FOOD": ["VEGETABLES", "COOKIES", "CAKES", "CUPCAKES", "FRUITS", "BACON", "CANDY", "CANDY_CANES", "CHOCOLATE", "DONUTS", "ICE_CREAM", "PIES", "PIZZAS",  "TACOS", "CHOCOLATE_CHIP_COOKIES", "EGGS","FRIED_EGG",  ], #BIRTHDAY_CAKES
"VEGETABLES": ["CABBAGE","TOMATOES","PUMPKINS","BROCCOLI",],
"FRUITS": ["LEMONS","GRAPES", "ORANGE","AVOCADOS" , "APPLES", 
"BANANAS", "BLACKBERRIES", "BLUEBERRIES", "CHERRIES", "DATES", "FIGS", "KUMQUATS",  "PAPAYAS", "PEACHES", "PEARS", "PINEAPPLES", "RASPBERRIES", "STRAWBERRIES", "WATERMELONS"],

"VESSELS_AND_VEHICLES":["BOATS", "CAR", "BIKES", "MOTORCYCLES", "PICKUP_TRUCKS",  "SAILBOATS", "SHIPS", "TRACTORS","TRAINS","TRUCKS","HARLEY_DAVIDSON", "KAYAKS", "1957_DE_SOTO_FIREFLIGHT_2DOOR_SPORTSMAN", 
"VANS", "AIRSTREAMS", "BUS",  "FIRE_TRUCKS", "HELICOPTERS", "JETS", "JETSKIS", "PLANES", "TROLLY",  "VESPAS", "OLD_CAR", "OLD_TRUCKS", 

 ],
    
"TOYS": ["TEDDY_BEAR", "DOLLS", "STUFFED_ANIMALS", "SCOOTERS", "ROCKING_HORSES", "ALPHABET_BLOCKS"],

# OCEAN/BEACH works better than OCEAN/SEA/BEACH
"NATURE_SCENES": ["OCEAN/BEACH", "FORESTS", "MOUNTAINS", "SNOW", "JUNGLE", "SUNRISE/SUNSET", "LAKE", "RIVERS", "SKY",  "WAVES", "SKY_SPACE", "WATERFALLS", "STREAMS"],

"ACTIVITIES":["FISHING","DANCING","CAMPING", "COOKING", "ICE_SKATING", "YOGA","PARTIES", "CRAFTS", "KNITTING","SKIING", ],

"SPORT": ["BASEBALL", "FOOTBALL", "GOLF", "SOCCER", "SURFING","BASKETBALL", "TENNIS", "SAILING", ],

"MYTHIC_CREATURES": ["GHOSTS",  "SKELETON", "UNICORNS", "ANGELS", "FAIRIES", "WITCHES", "DRAGONS","MERMAIDS", "PEGASUS","CHUPACABRA", "VAMPIRES", "SASQUATCH", "WEREWOLVES", "ALIENS", "CUPID"],

"DECORATIONS": [ "SANTA_HATS", "MISTLETOE", "EASTER_EGGS", "CHRISTMAS_TREES", "BALLOONS", "SANTA_CLAUS", "WREATHS", "CHRISTMAS_ORNAMENTS", "CANDLES", "JACK_OLANTERNS",  "GRADUATION_CAPS", "CHALICES", "CHRISTMAS_LIGHTS", "DREAM_CATCHERS", "MENORAHS", "SLEIGHS", "STAR_OF_DAVID", ],
"ANIMATION_CHARACTERS": ["GINGERBREAD_MAN","GNOMES", ],

"MUSICAL_INSTRUMENTS": ["CDS", "TRUMPETS", "TUBAS", "BANJOS", "CASSETTE_TAPES", "CELLOS", "CLARINETS", "DRUMS", "FLUTES", "FRENCH_HORNS", "GUITARS", "HARPS", "JUKEBOX", "MICROPHONES","MUSIC_ALBUMS", "MUSICAL_NOTATIONS", "PIANO_KEYS", "PIANOS", "RADIOS", "ROCK_N_ROLL", "SAXOPHONES", "TROMBONES", "VIOLINS"],

"TEXTILES": ["DENIM", "FLORAL_PRINT", "GINGHAM", "HOUNDSTOOTH", "LEOPARD_PRINT", "PAISLEY", "PLAID", "POLKA_DOTS", "QUILTS", "STRIPES", "TIE_DYE", ],


"OTHERS": [ "FULL_MOON", "SUN", "MOON","BUILDINGS", "FARMS", "HOUSES",  "DRESS", "SHOES", "HAIR", 
           "US_FLAG", "COWBOYS", "TEACHERS", "SNOWMAN", "TEXTILES", "BABY", 
           "SCHOOL", "HUNTERS", "LOVE_ROMANTIC", "PARIS", "GAMES", "SCRABBLE", "SEAWEED","ROADS", 
           "SEATTLE", "GAVELS", "MASON_JARS", "HAUNTED_HOUSES", "CABINS", "BARNS", "SEASHELLS", 
           "CONFETTI", "GLOBES", "SAND_DOLLARS", "YARN", "MIDDLE_FINGERS", "GOLF_BALLS", "LACROSSE_BALLS", 
           "SOFTBALLS", "TENNIS_BALLS", "PARASOLS", "SMOKING_PIPE", "LOCKS", "CAMPFIRES", "FARM_HOUSE",
           "SLOT_MACHINES", "COFFEE_CUPS", "VASES","SHIPWRECK", "VIDEO_GAMES", "ZODIAC", 
           "PAINTING", "DOMINOS", "ASTRONAUTS", "NURSES","COWGIRLS",  "SUPERHEROS", "NESTS", "CLOUDS"
    # verb
"KISS", "HUGS", "EXERCISE", "FARTS", 

 "AMUSEMENT_RIDES", "CAROUSELS", "CIRCUS", "JACKPOT",
"WOMAN"],


# ADDED FROM tree_view
"ARTISTS": ["FRIDA_KAHLO", "EDUOARD_MANET", "JAN_VAN_EYCK", "JOHANNES_VERMEER", "LEONARDO_DA_VINCI", "RENOIR", "VINCENT_VAN_GOGH"],


"COSTUMES":["PARTY_HATS", "CROWNS","MASQUERADE_MASKS","BALLET_SLIPPERS", "SUITS", "CAPES_AND_GOWNS", "HATS","MUSTACHES","SOMBREROS", "BIKINI",],

"SHOES": ["ARMY_BOOTS", "BOOTS", "COWBOY_BOOTS", "FLIP_FLOPS", "HIGH_HEELS", "RAIN_BOOTS", "SNEAKERS"] ,


"TOOLS":["HAMMER"], 

"LANDMARKS":["SPACE_NEEDLE", ],

"FAMOUS_PEOPLE":["MONA_LISA", "TRUMP", "EDGAR_ALLEN_POE", "ALBERT_EINSTEIN",],


"SYMBOLS": ["CRUCIFIX", "HEARTS", "INFINITY_SYMBOL", "OLIVE_BRANCH", "OM_SYMBOL", "STARS", "PEACE", "TOTEMS"] ,
#"YIN_YANG"

}

GROUPS0 = [ "WEDDINGS",  "VEGETABLES", "DESSERTS", "BREAKFAST", "GIFTS", ]

GROUPS1 = [ "TOYS", "SPORTS", "ANIMALS","PLANTS", "FOOD", "VESSELS_AND_VEHICLES",  "BAKING","SYMBOLS", "ASTRONOMY",  
           "NATURE_SCENES",  "GARDENING", "MYTHIC_CREATURES","TOOLS", "COSTUMES", "LANDMARKS", "FAMOUS_PEOPLE", "EMOJI" ]

NON_OBJECTS = [
    
    # country
    "IRELAND","AMERICANA", "UNITED_STATES", "AFRICA","MEXICO","USA","AUSTRALIA","CHINA", 
    "CHINESE_LANGUAGE","CHINESE_THEMED","CHRISTIAN_THEMED", "IRISH_THEMED","ITALY", 
    "SPANISH_LANGUAGE", "WASHINGTON","JAPAN","SPAIN","ENGLAND", "HAWAIIAN_THEMED", 'CALIFORNIA',"CANADA","HAWAII", "ITALIAN_LANGUAGE",
    
    # color
    "GREEN","PINK","BLUE", "YELLOW","PURPLE","RED", "COLORS", "BLACK",
    
    # description 
    "CARD_STYLE", "COOL", "CUTE",  "GIRLY", "MANLY", "ART", "ROMANTIC",  "GLAMOR", "FANTASY","TECHY", "COUNTRY_LIVING", "HOLLY", "FASHION", "FURNISHING", "STILL_LIFE",
    "NATIVE_AMERICAN", "VINTAGE","TROPICAL", "CHRISTIANITY",  "JUDAISM","ASTROLOGY", "COVID", "LGBTQ","BIPOC","CATHOLICISM","MINIMALIST", "RETRO", "MASTER_PIECES", 
    "WEATHER","SEASONS","FALL","WINTER", "SPRING","SUMMER","NATIVITY_SCENE","FOLK_ART", "SCOTTISH_THEMED",
    
    # noun
    "MILITARY", "MILITARY_SERVICE", "FARMS", "TRAVEL", "READING", "PLACES", "CARTOONS", "WRITERS", "ACTORS", "ARMY", "US_AIR_FORCE","BEAUTY",  'LANDMARKS',
    
    # Not able to be detected
    "BIBLE_VERSES", "MARY", "VOLKSWAGENS", "EKG", "LASSOS",  "QUOTE", "SMILEY_FACES","ALICE_IN_WONDERLAND","DICTIONARY",
   # since almost all cards have quotes
]

#np.save("cleaned_features.npy", [OBJECTS, GROUPS0, GROUPS1, NON_OBJECTS])SMILING

